<?php
require("/home/spool/edugain-urn/Web/config.php");
require_once($realpath."/siLeDAP/LdapManager.php");
require_once($realpath."/siLeDAP/LdapConf.php");
require_once($realpath."/siLeDAP/xml2Array.php");

$URN_BASE="dc=urnreg,dc=edugain,dc=org";
$URN_VALUE_BASE="urn:geant:edugain";
$URN_PENDING='urn:mace:terena.org:schac:userStatus:edugain:registry:pending';

$MAIL_ADMIN="admin@domain.com";

$error='';

function echoURNDescription($urn) {
	$res='';
	$objs=$urn->getObjectClassList()->getValues();
	if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) {
		$res.="<urn value='".$urn->getSingleAttribute("urnRegValue")."' owner='".$urn->getSingleAttribute("urnRegOwner")."'>";
		$res.="  <httpsuri value='".$urn->getSingleAttribute("urnRegHttpURIHuman")."'/>";
		if ($urn->hasAttribute("urnRegLdapURI")) {
		$res.="  <ldapuri value='".$urn->getSingleAttribute("urnRegLdapURI")."'/>";
		}
		$res.="</urn>";
	}
	else {
		$res.="<urn value='".$urn->getSingleAttribute("urnRegValue")."'>";
		if ($urn->hasAttribute("urnRegValueDescription")) {
			$res.="<descriptions>";
			foreach ($urn->getAttribute("urnRegValueDescription")->getArrayValues() as $descattr) {
				$res.="  <description value='".$descattr['value']."' />";
			}
			$res.="</descriptions>";
		}
		if ($urn->hasAttribute("urnRegValuePresentation")) {
			$res.="<presentations>";
			$attr=$urn->getAttribute("urnRegValuePresentation");
			foreach ($attr->getArrayValues() as $repattr) {
				if (array_key_exists("lang",$repattr)) {
					$res.="  <presentation value='".$repattr['value']."' lang='".$repattr['lang']."' />";
				}
				else {
					$res.="  <presentation value='".$repattr['value']."' />";
				}
			}
			$res.="</presentations>";
		}
		if (in_array("urnRegContactPerson",$objs)) {
			$res.="<contactPerson>";
			$res.="   <givenName value='".$urn->getSingleAttribute("givenName")."' />";
			$res.="   <sn1 value='".$urn->getSingleAttribute("sn1")."' />";
			$res.="   <sn2 value='".$urn->getSingleAttribute("sn2")."' />";
			$res.="   <cn value='".$urn->getSingleAttribute("cn")."' />";
			$res.="   <mail value='".$urn->getSingleAttribute("mail")."' />";
			$res.="   <postalAddress value='".$urn->getSingleAttribute("postalAddress")."' />";
			$res.="   <phone value='".$urn->getSingleAttribute("telephoneNumber")."' />";
			$res.="</contactPerson>";
		}
		$res.="</urn>";
	}
	
	return $res;
}

function getURN($lm,$urnvalue) {
	GLOBAL $URN_BASE;
	
	$resState=false;
	$urn=getURNEntry($lm,$urnvalue);
	if ($urn->hasAttribute("userSchacStatus")==false) {
		$objs=$urn->getObjectClassList()->getValues();
		if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) {
			$urnvalue=$urn->getSingleAttribute("urnRegValue");
			$wsEP=$urn->getSingleAttribute("urnRegHttpURIHuman");
			$resState=getDelegatedURN($urnvalue,$wsEP);
		}
		else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) {
			echo echoURNDescription($urn);
			$resState=true;
		}
	}
	return $resState;
}

function getURNEntry($lm,$urnvalue) {
	GLOBAL $URN_BASE;

	$filter="(urnRegValue=".$urnvalue.")";
	$entries=$lm->search($URN_BASE,$filter);
	if (count($entries)==1) {
		$urn=$entries[0];
		return $urn;
	}
	return "";
}

function getDelegatedURNArray($urnvalue,$wsEP) {
	$params="?oper=geturn&urnvalue=".rawurlencode($urnvalue);
	
	$content='';
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $wsEP."siLeDAP/API/urn/urn.php".$params);
    curl_setopt($ch, CURLOPT_HEADER, 0); 
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
    ob_start();
    curl_exec ($ch);
    curl_close ($ch);
    $res = ob_get_contents();
    ob_end_clean();
    $objXML = new xml2Array();
    $arrayXML = $objXML->parse($res);
    
    $urnarray=$arrayXML[0]['children'][0];

	return $urnarray;	
}

function getDelegatedURN($urnvalue,$wsEP) {
	$urnarray=getDelegatedURNArray($urnvalue,$wsEP);
	
	return processUrnArray($urnarray,$wsEP);
}

function processUrnArray($urnarray,$wsEP) {
	echo "<urn value='".$urnarray['attrs']['VALUE']."' delegated='".$wsEP."'>";
	for ($i=0; $i<count($urnarray['children']); $i++) {
		if (strcmp($urnarray['children'][$i]['name'],"DESCRIPTIONS")==0) {
			echo "<descriptions>";
			$descs=$urnarray['children'][$i];
			for ($j=0; $j<count($descs['children']); $j++) {
				echo "<description value='".$descs['children'][$j]['attrs']['VALUE']."' />";
			}
			echo "</descriptions>";
		}
		else if (strcmp($urnarray['children'][$i]['name'],"PRESENTATIONS")==0) {
			echo "<presentations>";
			$precs=$urnarray['children'][$i];
			for ($j=0; $j<count($precs['children']); $j++) {
				if (array_key_exists('LANG',$precs['children'][$j]['attrs'])) {
					echo "<presentation value='".$precs['children'][$j]['attrs']['VALUE']."' lang='".$precs['children'][$j]['attrs']['LANG']."' />";
				}
				else {
					echo "<presentation value='".$precs['children'][$j]['attrs']['VALUE']."' />";
				}
			}
			echo "</presentations>";
		}
	}
	echo "</urn>";
	
	return true;
}

function getDelegatedSubURNs($urnvalue,$wsEP) {
	$arrayXML=getDelegatedSubURNsArray($urnvalue,$wsEP);
    
	return processDelegatedSubURNs($arrayXML,$wsEP);
}

function getDelegatedSubURNsArray($urnvalue,$wsEP) {
	$params="?oper=getsuburns&urnvalue=".rawurlencode($urnvalue);
	
	$content='';
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $wsEP."siLeDAP/API/urn/urn.php".$params);
    curl_setopt($ch, CURLOPT_HEADER, 0); 
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
    ob_start();
    curl_exec ($ch);
    curl_close ($ch);
    $res = ob_get_contents();
    ob_end_clean();
    $objXML = new xml2Array();
    $arrayXML = $objXML->parse($res);
    
    return $arrayXML;
}

function processDelegatedSubURNs($arrayXML,$wsEP) {
	echo "<urns>";
	if (strcmp($arrayXML[0]['children'][0]['name'],"URNS")==0) {
		$urns=$arrayXML[0]['children'][0]['children'];
		for ($i=0; $i<count($urns); $i++) {
		    $urnarray=$arrayXML[0]['children'][0]['children'][$i];
			processUrnArray($urnarray,$wsEP);
		}
	}
	echo "</urns>";
	
	return true;
}

function getSubURNs($lm,$urnvalue) {
	GLOBAL $URN_BASE;
	
	$resState=false;
	
	$filter="(urnRegValue=".$urnvalue.":*)";
	$entries=$lm->search($URN_BASE,$filter,false);
	usort($entries,"sortSubUrns");
	echo "<urns>";
	if (count($entries)>0) {
		$entryMin=$entries[0];
		$min=count(explode(":",$entryMin->getSingleAttribute("urnRegValue")));
		$end=false;
		for ($i=0; $i<count($entries)&&$end==false; $i++) {
			$entry=$entries[$i];
			if ($entry->hasAttribute("schacUserStatus")==false) {
				$tokens=count(explode(":",$entry->getSingleAttribute("urnRegValue")));
				if ($tokens>$min) {
					$end=true;
				}
				else {
					$objs=$entry->getObjectClassList()->getValues();
					if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) {
						$urnvalue=$entry->getSingleAttribute("urnRegValue");
						$wsEP=$entry->getSingleAttribute("urnRegHttpURIHuman");
						$resState=getDelegatedURN($urnvalue,$wsEP);
					}
					else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) {
						echo echoURNDescription($entry);
						$resState=true;
					}
				}
			}
		}
	}
	echo "</urns>";
	
	return $resState;
}

function searchSubURNs($lm,$urn,$search) {
	GLOBAL $URN_BASE;
	
	$resState=true;
	
	$filter="(urnRegValue=".$urn.":*)";
	$entries=$lm->search($URN_BASE,$filter,false,array("objectClass","urnRegValue"));
	usort($entries,"sortSubUrns");
	if (count($entries)>0) {
		$entryMin=$entries[0];
		$min=count(explode(":",$entryMin->getSingleAttribute("urnRegValue")));
		$end=false;
		for ($i=0; $i<count($entries)&&$end==false&&$resState==true; $i++) {
			$entry=$entries[$i];
			if ($entry->hasAttribute("schacUserStatus")==false) {
				$tokens=count(explode(":",$entry->getSingleAttribute("urnRegValue")));
				if ($tokens>$min) {
					$end=true;
				}
				else {
					$objs=$entry->getObjectClassList()->getValues();
					$urnvalue=$entry->getSingleAttribute("urnRegValue");
					if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) {
						$wsEP=$entry->getSingleAttribute("urnRegHttpURIHuman");
						$resState=searchURNs($lm,$urnvalue,$search,$wsEP);
					}
					else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) {
						$resState=searchURNs($lm,$urnvalue,$search);
					}
				}
			}
		}
	}
	
	return $resState;
}

function searchDelegatedSubURNs($lm,$urn,$search,$wsEP) {
	$resState=true;
	
	$arrayXML=getDelegatedSubURNsArray($urn,$wsEP);
	if (strcmp($arrayXML[0]['children'][0]['name'],"URNS")==0) {
		$urns=$arrayXML[0]['children'][0]['children'];
		for ($i=0; $i<count($urns)&&$resState==true; $i++) {
		    $urnarray=$arrayXML[0]['children'][0]['children'][$i];
		    
			$found=false;
		
			$urnvalue=$urnarray['attrs']['VALUE'];
			$found|=stripos($urnvalue,$search)!==false;
		
			for ($i=0; $i<count($urnarray['children']); $i++) {
				if (strcmp($urnarray['children'][$i]['name'],"DESCRIPTIONS")==0) {
					$descs=$urnarray['children'][$i];
					for ($j=0; $j<count($descs['children']); $j++) {
						$found|=stripos($descs['children'][$j]['attrs']['VALUE'],$search)!==false;
					}
				}
			}
			if ($found==true) {
				$resState=processUrnArray($urnarray,$wsEP);
			}
			$resState=searchURNs($lm,$urnvalue,$search,$wsEP);
		}
	}
	
	return $resState;
}

function searchURNs($lm,$urn,$search,$wsEP='') {
	$resState=false;
	
	if (strcmp($wsEP,"")==0) { // It's NOT a delegated URN
		$urnEntry=getURNEntry($lm,$urn);
		if (!is_string($urnEntry)) {
			$objs=$urnEntry->getObjectClassList()->getValues();
			$urnvalue=$urnEntry->getSingleAttribute("urnRegValue");
			if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) { // Anyway, we should check if it's a delegated URN
				$newWsEP=$urnEntry->getSingleAttribute("urnRegHttpURIHuman");
				$resState=searchURNs($lm,$urnvalue,$search,$newWsEP); // Searching again with its end point
			}
			else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) { // Actually, it's a description urn
				$urndescs=$urnEntry->getSingleAttribute("urnRegValueDescription");
				$found=false;
				foreach ($urnEntry->getAttribute("urnRegValueDescription")->getArrayValues() as $descattr) {
					$found|=stripos($descattr['value'],$search)!==false;
				}
				$found|=stripos($urnvalue,$search)!==false;
				if ($found==true) {
					echo echoURNDescription($urnEntry);
				}
				$resState=true;
			}
			// Search in sub URNs
			if ($resState==true) {
				$resState=searchSubURNs($lm,$urnvalue,$search);		
			}
		}
	}
	else {
		$urnarray=getDelegatedURNArray($urn,$wsEP);
		$found=false;
		
		$urnvalue=$urnarray['attrs']['VALUE'];
		$found|=stripos($urnvalue,$search)!==false;
		
		for ($i=0; $i<count($urnarray['children']); $i++) {
			if (strcmp($urnarray['children'][$i]['name'],"DESCRIPTIONS")==0) {
				$descs=$urnarray['children'][$i];
				for ($j=0; $j<count($descs['children']); $j++) {
					$found|=stripos($descs['children'][$j]['attrs']['VALUE'],$search)!==false;
				}
			}
		}
		if ($found==true) {
			$resState=processUrnArray($urnarray,$wsEP);
		}
		else {
			$resState=true;
		}
		if ($resState==true) {
			$resState=searchDelegatedSubURNs($lm,$urnvalue,$search,$wsEP);
		}
	}
	
	return $resState;
}

function sortSubUrns($elem1,$elem2) {
	$val1=explode(":",$elem1->getSingleAttribute("urnRegValue"));
	$val2=explode(":",$elem2->getSingleAttribute("urnRegValue"));
	return count($val1)>count($val2);
}

function uuid() {
    
    // The field names refer to RFC 4122 section 4.1.2

    return sprintf('%04x%04x-%04x-%03x4-%04x-%04x%04x%04x',
        mt_rand(0, 65535), mt_rand(0, 65535), // 32 bits for "time_low"
        mt_rand(0, 65535), // 16 bits for "time_mid"
        mt_rand(0, 4095),  // 12 bits before the 0100 of (version) 4 for "time_hi_and_version"
        bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)), '01', 6, 2)),
            // 8 bits, the last two of which (positions 6 and 7) are 01, for "clk_seq_hi_res"
            // (hence, the 2nd hex digit after the 3rd hyphen can only be 1, 5, 9 or d)
            // 8 bits for "clk_seq_low"
        mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535) // 48 bits for "node"  
    );  
}


function addUrnReg($lm,$dataXML) {
	GLOBAL $URN_PENDING;
	GLOBAL $URN_VALUE_BASE;
	GLOBAL $error;
	
	$xml = simplexml_load_string($dataXML);
	
	$objectClasses = array('urnRegDescriptionStr','urnRegContactPerson','irisObject','top','schacUserEntitlements');
	$uuid=uuid();
	$attrs = array();
	$address=base64_decode($xml->urn_data->contact_person->postal_address['value']);
	$tokenAddress=explode("\n",$address);
	$address=implode(" $ ",$tokenAddress);
	$address.=" $ ".base64_decode($xml->urn_data->contact_person->country['value']);
	
	$urnvalue=$xml->urn_data['value'];
	$parenturnA=explode(":",$urnvalue);
	array_pop($parenturnA);
	$parenturn=implode(":",$parenturnA);
	$valueparenturn=getURNEntry($lm,$parenturn);
	
	if (is_string($valueparenturn)) {
		$error="The parent URN ".$parenturn." has not been registered";
		return false;
	}
	else if (strcmp($urnvalue,"")==0||strpos($urnvalue,$URN_VALUE_BASE)===false) {
		$error="The URN is not valid";
		return false;
	}
	else if (strcmp(base64_decode($xml->urn_data->description['value']),"")==0) {
		$error="The description of the URN is not valid";
		return false;
	}
	else if (strcmp($xml->urn_data->contact_person->cn['value'],"")==0) {
		$error="The common name of the contact person is not valid";
		return false;
	}
	else if (strcmp($xml->urn_data->contact_person->email['value'],"")==0) {
		$error="The email of the contact person is not valid";
		return false;
	}
	else if (strcmp($xml->urn_data->contact_person->sn1['value'],"")==0) {
		$error="The first surname of the contact person is not valid";
		return false;
	}
	else if (strcmp($xml->urn_data->contact_person->given_name['value'],"")==0) {
		$error="The given name of the contact person is not valid";
		return false;
	}
	else if (strcmp(base64_decode($xml->urn_data->contact_person->postal_address['value']),"")==0) {
		$error="The postal address of the contact person is not valid";
		return false;
	}
	else if (strcmp(base64_decode($xml->urn_data->contact_person->country['value']),"")==0) {
		$error="The country of the contact person is not valid";
		return false;
	}
	else if (strcmp($xml->urn_data->contact_person->phone['value'],"")==0) {
		$error="The phone number of the contact person is not valid";
		return false;
	}
	$attrs['urnRegValue']=array(utf8_encode($xml->urn_data['value']));
	$attrs['urnRegValueDescription']=array(utf8_encode(base64_decode($xml->urn_data->description['value'])));
	$attrs['cn']=array(utf8_encode(base64_decode($xml->urn_data->contact_person->cn['value'])));
	$attrs['givenName']=array(utf8_encode(base64_decode($xml->urn_data->contact_person->given_name['value'])));
	$attrs['idnc']=array(utf8_encode($uuid));
	$attrs['mail']=array(utf8_encode(base64_decode($xml->urn_data->contact_person->email['value'])));
	$attrs['postalAddress']=array(utf8_encode($address));
	$attrs['sn1']=array(utf8_encode(base64_decode($xml->urn_data->contact_person->sn1['value'])));
	$attrs['sn2']=array(utf8_encode(base64_decode($xml->urn_data->contact_person->sn2['value'])));
	$attrs['telephoneNumber']=array(utf8_encode(base64_decode($xml->urn_data->contact_person->phone['value'])));
	if (count($xml->urn_data->presentations->presentation)>0) {
		foreach ($xml->urn_data->presentations->presentation as $pres) {
			$attrs['urnRegValuePresentation;lang-'.$pres['lang']]=array(utf8_encode(base64_decode($pres['value'])));
		}
	}
	$attrs['schacUserStatus']=array($URN_PENDING);
	$res=$lm->addEntry("idnc=".$uuid.",dc=urnreg,dc=edugain,dc=org",$objectClasses,$attrs);
	
	return $res;
}

function sendUrnRegEmail($dataXML) {
	GLOBAL $MAIL_ADMIN;
	
	$xml = simplexml_load_string($dataXML);
	
	$urn = $xml->urn_data['value'];
	$to = base64_decode($xml->urn_data->contact_person->email['value']);
	$subject = "[URNreg eduGAIN] Request for registering the URN ".$urn;
	$text = "Hi,\nThe request has been sent successfully. In an undefined period of time your request will be processed and you'll receive an email.\nRegards\n";
	$headers = 'From: '.$MAIL_ADMIN. "\r\n" .
    'Bcc: '.$MAIL_ADMIN. "\r\n" .
    'Reply-To: '.$MAIL_ADMIN. "\r\n" .
    'X-Mailer: PHP/' . phpversion();
	mail($to,$subject,$text,$headers);
}

function addUrnDel($dataXML) {
	return false;
}

function searchPendingURNs($lm,$urn) {
	GLOBAL $URN_BASE;

	$resState=true;
	
	$filter="(&(urnRegValue=".$urn.":*)(schacUserStatus=*))";
	$entries=$lm->search($URN_BASE,$filter,false);
	usort($entries,"sortSubUrns");
		for ($i=0; $i<count($entries); $i++) {
			$entry=$entries[$i];
				$tokens=count(explode(":",$entry->getSingleAttribute("urnRegValue")));
					$objs=$entry->getObjectClassList()->getValues();
					$urnvalue=$entry->getSingleAttribute("urnRegValue");
					if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) {
						echo echoURNDescription($entry);
						$resState=true;
					}
		}

	return $resState;
}

$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
$lm->connectLdap($LDAP_USER,$LDAP_PASS);

$success=false;

header('Content-type: text/xml');
echo "<Response>";
if (array_key_exists('oper',$_REQUEST)) {
   	$oper=$_REQUEST['oper'];
    if (strcmp($oper,"geturn")==0) { // Get an urn
        if (array_key_exists('urnvalue',$_REQUEST)) {
        	$urnvalue=rawurldecode($_REQUEST['urnvalue']);
        	if (array_key_exists('delegated',$_REQUEST)) {
        		$success=getDelegatedURN($urnvalue,rawurldecode($_REQUEST['delegated']));
        	}
        	else {
	        	$success=getURN($lm,$urnvalue);
        	}
        }
    }
    else if (strcmp($oper,"getsuburns")==0) { // Get sub urns
        if (array_key_exists('urnvalue',$_REQUEST)) {
        	$urnvalue=rawurldecode($_REQUEST['urnvalue']);
        	if (array_key_exists('delegated',$_REQUEST)) {
	        	$success=getDelegatedSubURNs($urnvalue,rawurldecode($_REQUEST['delegated']));
        	}
        	else {
	        	$success=getSubURNs($lm,$urnvalue);
        	}
        }
    }
    else if (strcmp($oper,"search")==0) { // Search urns
        if (array_key_exists('search',$_REQUEST)&&array_key_exists('urnbase',$_REQUEST)) {
        	$search=rawurldecode($_REQUEST['search']);
        	$urnbase=rawurldecode($_REQUEST['urnbase']);
        	$success=searchURNs($lm,$urnbase,$search);
        }
    }
    else if (strcmp($oper,"addurn")==0) { // Request a new urn
    	if (array_key_exists('urndata',$_REQUEST)) {
    		$urntype=rawurldecode($_REQUEST['urntype']);
    		$data=rawurldecode($_REQUEST['urndata']);
    		if (strcmp($urntype,"urnreg")==0) {
    			$success=addUrnReg($lm,$data);
    			if ($success) {
    				sendUrnRegEmail($data);
    			}
    		}
    		else {
    			$success=addUrnDel($data);
    		}
    	}
    }
    else if (strcmp($oper,"getpendingurn")==0) { // Get pendings URNs
    	$success=searchPendingURNs($lm,"urn:geant:edugain");
    }
}
if ($success==true) {
    echo "<OperationInfo><Status status='success'/></OperationInfo>";
}
else {
	if (strcmp($error,"")==0) {
		$error=$lm->getErrorMessage();
	}
    echo "<OperationInfo><Status status='fail'/><ErrorMessage message='".$error."'/></OperationInfo>";
}
echo "</Response>";

?>
